unit uframe2;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, StdCtrls, Grids,
  Dialogs, ExtCtrls, Eingabe, Graphics;

type

  { TFrame2 }

  TFrame2 = class(TFrame)
    BuAnlegen: TButton;
    BuAendern: TButton;
    BuLoeschen: TButton;
    BuZurueck: TButton;
    CBPersArt: TComboBox;
    CBPartnerAnr: TComboBox;
    EdtVorname: TEdit;
    EdtMail: TEdit;
    EdtLand: TEdit;
    EdtPartnerTel: TEdit;
    EdtPartnerVorname: TEdit;
    EdtPartnerName: TEdit;
    EdtName: TEdit;
    EdtStrasse: TEdit;
    EdtHausNr: TEdit;
    EdtPLZ: TEdit;
    EdtOrt: TEdit;
    EdtTel: TEdit;
    EdtHandy: TEdit;
    EdtFirmenname: TEdit;
    LblHeader: TLabel;
    LblHName: TLabel;
    LblStrasse: TLabel;
    LblHHausNr: TLabel;
    LblHPLZ: TLabel;
    LblHOrt: TLabel;
    LblHTel: TLabel;
    LblHHandy: TLabel;
    LblHMail: TLabel;
    LblHLand: TLabel;
    LblHPartnerAnr: TLabel;
    LblUnten: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    LblNr: TLabel;
    LblHPartnerVorName: TLabel;
    LblHPartnerName: TLabel;
    LblHPartnerTel: TLabel;
    LblFirmenName: TLabel;
    LblLinieOben: TLabel;
    LblLinieUnten: TLabel;
    LblLinieMitteU: TLabel;
    LblLinieMitteO: TLabel;
    LblHNr: TLabel;
    LblHPersArt: TLabel;
    LblHVorname: TLabel;
    SGEintraege: TStringGrid;
    Timer1: TTimer;
    procedure BuAnlegenClick(Sender: TObject);
    procedure BuAendernClick(Sender: TObject);
    procedure BuLoeschenClick(Sender: TObject);
    procedure BuZurueckClick(Sender: TObject);
    procedure CBPersArtChange(Sender: TObject);
    procedure CBPartnerAnrChange(Sender: TObject);
    procedure EdtMailKeyPress(Sender: TObject; var Key: Char);
    procedure EdtMailKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtLandKeyPress(Sender: TObject; var Key: Char);
    procedure EdtLandKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtPartnerTelKeyPress(Sender: TObject; var Key: Char);
    procedure EdtPartnerTelKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtPartnerVornameKeyPress(Sender: TObject; var Key: Char);
    procedure EdtPartnerVornameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtPartnerNameKeyPress(Sender: TObject; var Key: Char);
    procedure EdtPartnerNameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtVornameKeyPress(Sender: TObject; var Key: Char);
    procedure EdtVornameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtNameKeyPress(Sender: TObject; var Key: Char);
    procedure EdtNameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtStrasseKeyPress(Sender: TObject; var Key: Char);
    procedure EdtStrasseKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtHausNrKeyPress(Sender: TObject; var Key: Char);
    procedure EdtHausNrKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtPLZKeyPress(Sender: TObject; var Key: Char);
    procedure EdtPLZKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtOrtKeyPress(Sender: TObject; var Key: Char);
    procedure EdtOrtKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtTelKeyPress(Sender: TObject; var Key: Char);
    procedure EdtTelKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtHandyKeyPress(Sender: TObject; var Key: Char);
    procedure EdtHandyKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdtFirmennameKeyPress(Sender: TObject; var Key: Char);
    procedure EdtFirmennameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SGEintraegeSelectCell(Sender: TObject; aCol, aRow: Integer; var CanSelect: Boolean);
    procedure Timer1Timer(Sender: TObject);
  private
    AOwner: TComponent;
    FOnCloseMe: TNotifyEvent;
    procedure SetVariables(aialpha: String; ainummer, aiart, ainumkom, aikomma, aizeich, aistell, aifunc, ailanmax, ailanmin, aiautocr: Integer);
    procedure SetControlStatus(ctrl: TObject; aenabled: Boolean; atext: String = '');
  public
    constructor Create(AOwner1: TComponent); override;                          // Frame initialisieren (Variable und Komponenteneigenschaften)
    destructor Destroy; override;                                               // Frame schliessen
    procedure FBLoe;                                                            // Löschen Eingabefelder Bildschirm
    procedure Ladenpersonen;                                                    // Laden Daten Personen aus Tabelle in Stringgrid
  published
    property OnCloseMe: TNotifyEvent read FOnCloseMe write FOnCloseMe;
  end;

type
  Tfperson = record                                                           // Satzaufbau Personen
    Nummer: Integer;
    Art: String;                                                                  // Person/Firma
    Firmenname: String;
    Vorname: String;
    Nachname: String;
    Strasse: String;
    Hausnummer: String;
    Plz: String;
    Ort: String;
    Land: String;
    Telefon: String;
    Handy: String;
    Email: String;
    Partneranrede: String;
    Partnervorname: String;
    Partnernachname: String;
    Partnertelefon: String;
    Satzart: Boolean;                                                             // aktiv/passiv
  end;

var
  ftasts: Boolean;                                                              // Darf ein Button gedrückt werden
  fart: Integer;                                                                // Verarbeitungsart 1=Insert 2=Update 3=Delete
  flauf: Integer;                                                               // Welche Eingabe ist zulässig 0=keine Eingabe
  fgrid: Integer;                                                               // Nummer der angeklickten Zeile im Stringgrid
  fperson: Tfperson;

implementation

{$R *.lfm}

uses
  uprjhelper, upersonen;

  { TFrame2 }

destructor TFrame2.Destroy;
begin
  AOwner.Free;
  inherited Destroy;
end;

procedure TFrame2.BuZurueckClick(Sender: TObject);
begin
  LblHeader.Caption := UTF8Encode(#169) + 'LINSOFT               Projektverwaltung                   Datum: ' + FormatDateTime('DD.MM.YYYY', now);
  if ftasts then
  begin
    LblUnten.Caption := '';
    ftasts := False;
    fart := 0;
    flauf := 0;
    if assigned(FOnCloseMe) then
      FOnCloseMe(self);
  end;
end;

procedure TFrame2.CBPersArtChange(Sender: TObject);
var
  h1: String;
begin
  if flauf = 1 then
  begin
    LblUnten.Caption := '';
    h1 := CBPersArt.Text;
    ialpha := Blankweg(3, h1);
    if ialpha <> '' then
    begin
      fperson.Art := ialpha;
      SetControlStatus(CBPersArt, False, '@');
      if ialpha = 'Person' then
      begin
        flauf := 3;
        SetControlStatus(EdtVorname, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          EdtVorname.Text := fperson.Vorname;
          ialpha := fperson.Vorname;
          iart := 1;
        end;
      end
      else
      begin
        flauf := 2;
        SetControlStatus(EdtFirmenname, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          EdtFirmenname.Text := fperson.Firmenname;
          ialpha := fperson.Firmenname;
          iart := 1;
        end;
      end;
    end
    else
    begin
      LblUnten.Caption := 'Personenart muss ausgewählt werden';
    end;
  end;
end;

procedure TFrame2.CBPartnerAnrChange(Sender: TObject);
var
  h1: String;
  h2: Integer;
  JaNein: TModalResult;
begin
  if flauf = 13 then
  begin
    LblUnten.Caption := '';
    h1 := CBPartnerAnr.Text;
    ialpha := Blankweg(3, h1);
    if ialpha <> '' then
    begin
      fperson.Partneranrede := ialpha;
      SetControlStatus(CBPartnerAnr, True, '@');
      if ialpha = 'ohne' then
      begin
        if fart = 1 then
        begin
          JaNein := messagedlg('Person/Firma anlegen?', mtConfirmation, [mbYes, mbNo], 0);
          if (JaNein = mrYes) then
          begin
            h2 := fperson.Nummer;
            Persontab[h2].Nummer := h2;
            Persontab[h2].Art := fperson.Art;
            Persontab[h2].Land := fperson.Land;
            Persontab[h2].Email := fperson.Email;
            Persontab[h2].Handy := fperson.Handy;
            Persontab[h2].Telefon := fperson.Telefon;
            Persontab[h2].Ort := fperson.Ort;
            Persontab[h2].Plz := fperson.Plz;
            Persontab[h2].Hausnummer := fperson.Hausnummer;
            Persontab[h2].Strasse := fperson.Strasse;
            Persontab[h2].Nachname := fperson.Nachname;
            Persontab[h2].Firmenname := fperson.Firmenname;
            Persontab[h2].Vorname := fperson.Vorname;
            Persontab[h2].Partnertelefon := fperson.Partnertelefon;
            Persontab[h2].Partnernachname := fperson.Partnernachname;
            Persontab[h2].Partnervorname := fperson.Partnervorname;
            Persontab[h2].Partneranrede := fperson.Partneranrede;
            Persontab[h2].Satzart := True;
            Personzaehl := Personzaehl + 1;
            Updperson := True;
            Ladenpersonen;
          end;
        end
        else
        begin
          JaNein := messagedlg('Person/Firma ändern?', mtConfirmation, [mbYes, mbNo], 0);
          if (JaNein = mrYes) then
          begin
            h2 := fperson.Nummer;
            Persontab[h2].Nummer := h2;
            Persontab[h2].Art := fperson.Art;
            Persontab[h2].Land := fperson.Land;
            Persontab[h2].Email := fperson.Email;
            Persontab[h2].Handy := fperson.Handy;
            Persontab[h2].Telefon := fperson.Telefon;
            Persontab[h2].Ort := fperson.Ort;
            Persontab[h2].Plz := fperson.Plz;
            Persontab[h2].Hausnummer := fperson.Hausnummer;
            Persontab[h2].Strasse := fperson.Strasse;
            Persontab[h2].Nachname := fperson.Nachname;
            Persontab[h2].Firmenname := fperson.Firmenname;
            Persontab[h2].Vorname := fperson.Vorname;
            Persontab[h2].Partnertelefon := fperson.Partnertelefon;
            Persontab[h2].Partnernachname := fperson.Partnernachname;
            Persontab[h2].Partnervorname := fperson.Partnervorname;
            Persontab[h2].Partneranrede := fperson.Partneranrede;
            Persontab[h2].Satzart := True;
            Updperson := True;
            Ladenpersonen;
          end;
        end;
        flauf := 0;
        fart := 0;
        ftasts := True;
        FBLoe;
      end
      else
      begin
        flauf := 14;
        SetControlStatus(EdtPartnerTel, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 20, 1, 1);
        if fart = 2 then
        begin
          EdtPartnerTel.Text := fperson.Partnertelefon;
          ialpha := fperson.Partnertelefon;
          iart := 1;
        end;
      end;
    end
    else
    begin
      LblUnten.Caption := 'Partneranrede muss ausgewählt werden';
    end;
  end;
end;

procedure TFrame2.EdtMailKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 11 then
  begin
    itaste := Key;
    FeldEingabe(EdtMail);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtMailKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 11 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtMail, False, '@');
      h1 := EdtMail.Text;
      ialpha := Blankweg(3, h1);
      fperson.Email := ialpha;
      flauf := 12;
      SetControlStatus(EdtLand, True);
      SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
      if fart = 2 then
      begin
        EdtLand.Text := fperson.Land;
        ialpha := fperson.Land;
        iart := 1;
      end;
    end;
  end;
end;

procedure TFrame2.EdtLandKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 12 then
  begin
    itaste := Key;
    FeldEingabe(EdtLand);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtLandKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
  h2: Integer;
  JaNein: TModalResult;
begin
  Shift := Shift;
  if flauf = 12 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtLand, False, '@');
      h1 := EdtLand.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Land := ialpha;
        if fperson.Art = 'Person' then
        begin
          if fart = 1 then
          begin
            JaNein := messagedlg('Person/Firma anlegen?', mtConfirmation, [mbYes, mbNo], 0);
            if (JaNein = mrYes) then
            begin
              h2 := fperson.Nummer;
              Persontab[h2].Nummer := h2;
              Persontab[h2].Art := fperson.Art;
              Persontab[h2].Land := fperson.Land;
              Persontab[h2].Email := fperson.Email;
              Persontab[h2].Handy := fperson.Handy;
              Persontab[h2].Telefon := fperson.Telefon;
              Persontab[h2].Ort := fperson.Ort;
              Persontab[h2].Plz := fperson.Plz;
              Persontab[h2].Hausnummer := fperson.Hausnummer;
              Persontab[h2].Strasse := fperson.Strasse;
              Persontab[h2].Nachname := fperson.Nachname;
              Persontab[h2].Firmenname := fperson.Firmenname;
              Persontab[h2].Vorname := fperson.Vorname;
              Persontab[h2].Partnertelefon := fperson.Partnertelefon;
              Persontab[h2].Partnernachname := fperson.Partnernachname;
              Persontab[h2].Partnervorname := fperson.Partnervorname;
              Persontab[h2].Partneranrede := fperson.Partneranrede;
              Persontab[h2].Satzart := True;
              Personzaehl := Personzaehl + 1;
              Updperson := True;
              Ladenpersonen;
            end;
          end
          else
          begin
            JaNein := messagedlg('Person/Firma ändern?', mtConfirmation, [mbYes, mbNo], 0);
            if (JaNein = mrYes) then
            begin
              h2 := fperson.Nummer;
              Persontab[h2].Nummer := h2;
              Persontab[h2].Art := fperson.Art;
              Persontab[h2].Land := fperson.Land;
              Persontab[h2].Email := fperson.Email;
              Persontab[h2].Handy := fperson.Handy;
              Persontab[h2].Telefon := fperson.Telefon;
              Persontab[h2].Ort := fperson.Ort;
              Persontab[h2].Plz := fperson.Plz;
              Persontab[h2].Hausnummer := fperson.Hausnummer;
              Persontab[h2].Strasse := fperson.Strasse;
              Persontab[h2].Nachname := fperson.Nachname;
              Persontab[h2].Firmenname := fperson.Firmenname;
              Persontab[h2].Vorname := fperson.Vorname;
              Persontab[h2].Partnertelefon := fperson.Partnertelefon;
              Persontab[h2].Partnernachname := fperson.Partnernachname;
              Persontab[h2].Partnervorname := fperson.Partnervorname;
              Persontab[h2].Partneranrede := fperson.Partneranrede;
              Persontab[h2].Satzart := True;
              Updperson := True;
              Ladenpersonen;
            end;
          end;
          flauf := 0;
          fart := 0;
          ftasts := True;
          FBLoe;
        end
        else
        begin
          flauf := 13;
          SetControlStatus(CBPartnerAnr, True, 'ohne');
        end;
      end
      else
      begin
        LblUnten.Caption := 'Land muss eingegeben werden';
        SetControlStatus(EdtLand, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          EdtLand.Text := fperson.Land;
          ialpha := fperson.Land;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.EdtPartnerTelKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 14 then
  begin
    itaste := Key;
    FeldEingabe(EdtPartnerTel);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtPartnerTelKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 14 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtPartnerTel, False, '@');
      h1 := ialpha;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Partnertelefon := ialpha;
        flauf := 15;
        SetControlStatus(EdtPartnerVorname, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          EdtPartnerVorname.Text := fperson.Partnervorname;
          ialpha := fperson.Partnervorname;
          iart := 1;
        end;
      end
      else
      begin
        LblUnten.Caption := 'Partnertelefon muss eingegeben werden';
        SetControlStatus(EdtPartnerTel, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 20, 1, 1);
        if fart = 2 then
        begin
          EdtPartnerTel.Text := fperson.Partnertelefon;
          ialpha := fperson.Partnertelefon;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.EdtPartnerVornameKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 15 then
  begin
    itaste := Key;
    FeldEingabe(EdtPartnerVorname);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtPartnerVornameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 15 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtPartnerVorname, False, '@');
      h1 := EdtPartnerVorname.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Partnervorname := ialpha;
        flauf := 16;
        SetControlStatus(EdtPartnerName, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          EdtPartnerName.Text := fperson.Partnernachname;
          ialpha := fperson.Partnernachname;
          iart := 1;
        end;
      end
      else
      begin
        LblUnten.Caption := 'Partnervorname muss eingegeben werden';
        SetControlStatus(EdtPartnerVorname, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 20, 1, 1);
        if fart = 2 then
        begin
          EdtPartnerVorname.Text := fperson.Partnertelefon;
          ialpha := fperson.Partnertelefon;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.EdtPartnerNameKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 16 then
  begin
    itaste := Key;
    FeldEingabe(EdtPartnerName);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtPartnerNameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
  h2: Integer;
  JaNein: TModalResult;
begin
  Shift := Shift;
  if flauf = 16 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtPartnerName, False, '@');
      h1 := EdtPartnerName.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Partnernachname := ialpha;
        if fart = 1 then
        begin
          JaNein := messagedlg('Person/Firma anlegen?', mtConfirmation, [mbYes, mbNo], 0);
          if (JaNein = mrYes) then
          begin
            h2 := fperson.Nummer;
            Persontab[h2].Nummer := h2;
            Persontab[h2].Art := fperson.Art;
            Persontab[h2].Land := fperson.Land;
            Persontab[h2].Email := fperson.Email;
            Persontab[h2].Handy := fperson.Handy;
            Persontab[h2].Telefon := fperson.Telefon;
            Persontab[h2].Ort := fperson.Ort;
            Persontab[h2].Plz := fperson.Plz;
            Persontab[h2].Hausnummer := fperson.Hausnummer;
            Persontab[h2].Strasse := fperson.Strasse;
            Persontab[h2].Nachname := fperson.Nachname;
            Persontab[h2].Firmenname := fperson.Firmenname;
            Persontab[h2].Vorname := fperson.Vorname;
            Persontab[h2].Partnertelefon := fperson.Partnertelefon;
            Persontab[h2].Partnernachname := fperson.Partnernachname;
            Persontab[h2].Partnervorname := fperson.Partnervorname;
            Persontab[h2].Partneranrede := fperson.Partneranrede;
            Persontab[h2].Satzart := True;
            Personzaehl := Personzaehl + 1;
            Updperson := True;
            Ladenpersonen;
          end;
        end
        else
        begin
          JaNein := messagedlg('Person/Firma ändern?', mtConfirmation, [mbYes, mbNo], 0);
          if (JaNein = mrYes) then
          begin
            h2 := fperson.Nummer;
            Persontab[h2].Nummer := h2;
            Persontab[h2].Art := fperson.Art;
            Persontab[h2].Land := fperson.Land;
            Persontab[h2].Email := fperson.Email;
            Persontab[h2].Handy := fperson.Handy;
            Persontab[h2].Telefon := fperson.Telefon;
            Persontab[h2].Ort := fperson.Ort;
            Persontab[h2].Plz := fperson.Plz;
            Persontab[h2].Hausnummer := fperson.Hausnummer;
            Persontab[h2].Strasse := fperson.Strasse;
            Persontab[h2].Nachname := fperson.Nachname;
            Persontab[h2].Firmenname := fperson.Firmenname;
            Persontab[h2].Vorname := fperson.Vorname;
            Persontab[h2].Partnertelefon := fperson.Partnertelefon;
            Persontab[h2].Partnernachname := fperson.Partnernachname;
            Persontab[h2].Partnervorname := fperson.Partnervorname;
            Persontab[h2].Partneranrede := fperson.Partneranrede;
            Persontab[h2].Satzart := True;
            Updperson := True;
            Ladenpersonen;
          end;
        end;
        flauf := 0;
        fart := 0;
        ftasts := True;
        FBLoe;
      end
      else
      begin
        LblUnten.Caption := 'Partnernachname muss eingegeben werden';
        SetControlStatus(EdtPartnerName, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          EdtPartnerName.Text := fperson.Partnernachname;
          ialpha := fperson.Partnernachname;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.EdtVornameKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 3 then
  begin
    itaste := Key;
    FeldEingabe(EdtVorname);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtVornameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 3 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtVorname, False, '@');
      h1 := EdtVorname.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Vorname := ialpha;
        flauf := 4;
        SetControlStatus(EdtName, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          EdtName.Text := fperson.Nachname;
          ialpha := fperson.Nachname;
          iart := 1;
        end;
      end
      else
      begin
        LblUnten.Caption := 'Vorname muss eingegeben werden';
        SetControlStatus(EdtVorname, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          EdtVorname.Text := fperson.Vorname;
          ialpha := fperson.Vorname;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.EdtNameKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 4 then
  begin
    itaste := Key;
    FeldEingabe(EdtName);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtNameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 4 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtName, False, '@');
      h1 := EdtName.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Nachname := ialpha;
        flauf := 5;
        SetControlStatus(EdtStrasse, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          EdtStrasse.Text := fperson.Strasse;
          ialpha := fperson.Strasse;
          iart := 1;
        end;
      end
      else
      begin
        LblUnten.Caption := 'Nachname muss eingegeben werden';
        SetControlStatus(EdtName, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          EdtName.Text := fperson.Nachname;
          ialpha := fperson.Nachname;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.EdtStrasseKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 5 then
  begin
    itaste := Key;
    FeldEingabe(EdtStrasse);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtStrasseKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 5 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtStrasse, False, '@');
      h1 := EdtStrasse.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Strasse := ialpha;
        flauf := 6;
        SetControlStatus(EdtHausNr, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 5, 1, 1);
        if fart = 2 then
        begin
          EdtHausNr.Text := fperson.Hausnummer;
          ialpha := fperson.Hausnummer;
          iart := 1;
        end;
      end
      else
      begin
        LblUnten.Caption := 'Strasse muss eingegeben werden';
        SetControlStatus(EdtStrasse, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          EdtStrasse.Text := fperson.Strasse;
          ialpha := fperson.Strasse;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.EdtHausNrKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 6 then
  begin
    itaste := Key;
    FeldEingabe(EdtHausNr);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtHausNrKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 6 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtHausNr, False, '@');
      h1 := ialpha;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Hausnummer := ialpha;
        flauf := 7;
        SetControlStatus(EdtPLZ, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 10, 1, 1);
        if fart = 2 then
        begin
          EdtPLZ.Text := fperson.Plz;
          ialpha := fperson.Plz;
          iart := 1;
        end;
      end
      else
      begin
        LblUnten.Caption := 'Hausnummer muss eingegeben werden';
        SetControlStatus(EdtHausNr, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 5, 1, 1);
        if fart = 2 then
        begin
          EdtHausNr.Text := fperson.Hausnummer;
          ialpha := fperson.Hausnummer;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.EdtPLZKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 7 then
  begin
    itaste := Key;
    FeldEingabe(EdtPLZ);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtPLZKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 7 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtPLZ, False, '@');
      h1 := ialpha;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Plz := ialpha;
        flauf := 8;
        SetControlStatus(EdtOrt, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          EdtOrt.Text := fperson.Ort;
          ialpha := fperson.Ort;
          iart := 1;
        end;
      end
      else
      begin
        LblUnten.Caption := 'Postleitzahl muss eingegeben werden';
        SetControlStatus(EdtPLZ, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 10, 1, 1);
        if fart = 2 then
        begin
          EdtPLZ.Text := fperson.Plz;
          ialpha := fperson.Plz;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.EdtOrtKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 8 then
  begin
    itaste := Key;
    FeldEingabe(EdtOrt);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtOrtKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 8 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtOrt, False, '@');
      h1 := EdtOrt.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Ort := ialpha;
        flauf := 9;
        SetControlStatus(EdtTel, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 20, 1, 1);
        if fart = 2 then
        begin
          EdtTel.Text := fperson.Telefon;
          ialpha := fperson.Telefon;
          iart := 1;
        end;
      end
      else
      begin
        LblUnten.Caption := 'Ort muss eingegeben werden';
        SetControlStatus(EdtOrt, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          EdtOrt.Text := fperson.Ort;
          ialpha := fperson.Ort;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.EdtTelKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 9 then
  begin
    itaste := Key;
    FeldEingabe(EdtTel);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtTelKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 9 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtTel, False, '@');
      h1 := ialpha;
      ialpha := Blankweg(3, h1);
      fperson.Telefon := ialpha;
      flauf := 10;
      SetControlStatus(EdtHandy, True);
      SetVariables('', 0, 2, 0, 0, 3, 0, 5, 20, 1, 1);
      if fart = 2 then
      begin
        EdtHandy.Text := fperson.Handy;
        ialpha := fperson.Handy;
        iart := 1;
      end;
    end;
  end;
end;

procedure TFrame2.EdtHandyKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 10 then
  begin
    itaste := Key;
    FeldEingabe(EdtHandy);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtHandyKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 10 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtHandy, False, '@');
      h1 := ialpha;
      ialpha := Blankweg(3, h1);
      fperson.Handy := ialpha;
      if ((fperson.Telefon = '') and (fperson.Handy = '')) then
      begin
        LblUnten.Caption := 'Telefon und/oder Handy muss eingegeben werden';
        flauf := 9;
        SetControlStatus(EdtTel, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 20, 1, 1);
        if fart = 2 then
        begin
          EdtTel.Text := fperson.Telefon;
          ialpha := fperson.Telefon;
          iart := 1;
        end;
      end
      else
      begin
        flauf := 11;
        SetControlStatus(EdtMail, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          EdtMail.Text := fperson.Email;
          ialpha := fperson.Email;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.EdtFirmennameKeyPress(Sender: TObject; var Key: Char);
begin
  if flauf = 2 then
  begin
    itaste := Key;
    FeldEingabe(EdtFirmenname);
    Key := itaste;
  end;
end;

procedure TFrame2.EdtFirmennameKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  h1: String;
begin
  Shift := Shift;
  if flauf = 2 then
  begin
    if ((istell = ilanmax) and (Ord(itaste) > 0) and (iautocr = 1)) then
    begin
      Key := Ord(chr(13));
    end;
    if Ord(Key) = 13 then
    begin
      LblUnten.Caption := '';
      istell := 0;
      SetControlStatus(EdtFirmenname, False, '@');   //text='@' - don't change!!!
      h1 := EdtFirmenname.Text;
      ialpha := Blankweg(3, h1);
      if ialpha <> '' then
      begin
        fperson.Firmenname := ialpha;
        flauf := 3;
        SetControlStatus(EdtVorname, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 25, 1, 1);
        if fart = 2 then
        begin
          EdtVorname.Text := fperson.Vorname;
          ialpha := fperson.Vorname;
          iart := 1;
        end;
      end
      else
      begin
        LblUnten.Caption := 'Firmenname muss eingegeben werden';
        SetControlStatus(EdtFirmenname, True);
        SetVariables('', 0, 2, 0, 0, 3, 0, 5, 30, 1, 1);
        if fart = 2 then
        begin
          EdtFirmenname.Text := fperson.Firmenname;
          ialpha := fperson.Firmenname;
          iart := 1;
        end;
      end;
    end;
  end;
end;

procedure TFrame2.BuAnlegenClick(Sender: TObject);
var
  h1: Integer;
  h2: Integer;
begin
  LblHeader.Caption := UTF8Encode(#169) + 'LINSOFT               Projektverwaltung                   Datum: ' + FormatDateTime('DD.MM.YYYY', now);
  if ftasts then
  begin
    LblUnten.Caption := '';
    h2 := 0;
    for h1 := 1 to Personmax do
    begin
      if h2 = 0 then
      begin
        if not Persontab[h1].Satzart then
        begin
          h2 := h1;
        end;
      end;
    end;
    if h2 > 0 then
    begin
      fperson.Nummer := h2;
      fperson.Firmenname := '';
      fperson.Partneranrede := '';
      fperson.Partnervorname := '';
      fperson.Partnernachname := '';
      fperson.Partnertelefon := '';
      fperson.Satzart := True;
      LblNr.Caption := IntToStr(h2);
      ftasts := False;
      fart := 1;
      flauf := 1;
      SetControlStatus(CBPersArt, True);
    end
    else
    begin
      LblUnten.Caption := 'kein anlegen Person mehr möglich, maximale Anzahl erreicht';
    end;
  end;
end;

procedure TFrame2.BuAendernClick(Sender: TObject);
var
  h1: String;
  h2: Integer;
begin
  LblHeader.Caption := UTF8Encode(#169) + 'LINSOFT               Projektverwaltung                   Datum: ' + FormatDateTime('DD.MM.YYYY', now);
  if ftasts then
  begin
    LblUnten.Caption := '';
    if fgrid > 0 then
    begin
      h1 := SGEintraege.Cells[0, fgrid];
      h2 := Length(h1);
      if h2 > 0 then
      begin
        h2 := StrToInt(h1);
        if ((h2 > 0) and (h2 < 10000)) then
        begin
          ftasts := False;
          fart := 2;
          flauf := 1;
          fperson.Nummer := h2;
          fperson.Art := Persontab[h2].Art;
          fperson.Satzart := Persontab[h2].Satzart;
          fperson.Vorname := Persontab[h2].Vorname;
          fperson.Nachname := Persontab[h2].Nachname;
          fperson.Strasse := Persontab[h2].Strasse;
          fperson.Hausnummer := Persontab[h2].Hausnummer;
          fperson.Plz := Persontab[h2].Plz;
          fperson.Ort := Persontab[h2].Ort;
          fperson.Telefon := Persontab[h2].Telefon;
          fperson.Handy := Persontab[h2].Handy;
          fperson.Email := Persontab[h2].Email;
          fperson.Land := Persontab[h2].Land;
          fperson.Firmenname := Persontab[h2].Firmenname;
          fperson.Partneranrede := Persontab[h2].Partneranrede;
          fperson.Partnervorname := Persontab[h2].Partnervorname;
          fperson.Partnernachname := Persontab[h2].Partnernachname;
          fperson.Partnertelefon := Persontab[h2].Partnertelefon;
          fperson.Satzart := True;
          CBPartnerAnr.Text := fperson.Partneranrede;
          EdtVorname.Text := fperson.Vorname;
          EdtName.Text := fperson.Nachname;
          EdtStrasse.Text := fperson.Strasse;
          EdtHausNr.Text := fperson.Hausnummer;
          EdtPLZ.Text := fperson.Plz;
          EdtOrt.Text := fperson.Ort;
          EdtTel.Text := fperson.Telefon;
          EdtHandy.Text := fperson.Handy;
          EdtFirmenname.Text := fperson.Firmenname;
          EdtMail.Text := fperson.Email;
          EdtLand.Text := fperson.Land;
          EdtPartnerTel.Text := fperson.Partnertelefon;
          EdtPartnerVorname.Text := fperson.Partnervorname;
          EdtPartnerName.Text := fperson.Partnernachname;
          LblNr.Caption := IntToStr(h2);
          SetControlStatus(CBPersArt, True, fperson.Art);
        end
        else
        begin
          LblUnten.Caption := 'Perosnennummer nicht zulässig';
        end;
      end
      else
      begin
        LblUnten.Caption := 'Perosnennummer ist leer';
      end;
    end
    else
    begin
      LblUnten.Caption := 'erst Person/Firma im Stringgrid anklicken';
    end;
  end;
end;

procedure TFrame2.BuLoeschenClick(Sender: TObject);
var
  h1: String;
  h2: Integer;
  JaNein: TModalResult;
begin
  LblHeader.Caption := UTF8Encode(#169) + 'LINSOFT               Projektverwaltung                   Datum: ' + FormatDateTime('DD.MM.YYYY', now);
  if ftasts then
  begin
    LblUnten.Caption := '';
    if fgrid > 0 then
    begin
      h1 := SGEintraege.Cells[0, fgrid];
      h2 := Length(h1);
      if h2 > 0 then
      begin
        h2 := StrToInt(h1);
        if ((h2 > 0) and (h2 < 10000)) then
        begin
          ftasts := False;
          fart := 3;
          flauf := 0;
          fperson.Nummer := h2;
          fperson.Art := Persontab[h2].Art;
          fperson.Satzart := Persontab[h2].Satzart;
          fperson.Vorname := Persontab[h2].Vorname;
          fperson.Nachname := Persontab[h2].Nachname;
          fperson.Strasse := Persontab[h2].Strasse;
          fperson.Hausnummer := Persontab[h2].Hausnummer;
          fperson.Plz := Persontab[h2].Plz;
          fperson.Ort := Persontab[h2].Ort;
          fperson.Telefon := Persontab[h2].Telefon;
          fperson.Handy := Persontab[h2].Handy;
          fperson.Email := Persontab[h2].Email;
          fperson.Land := Persontab[h2].Land;
          fperson.Firmenname := Persontab[h2].Firmenname;
          fperson.Partneranrede := Persontab[h2].Partneranrede;
          fperson.Partnervorname := Persontab[h2].Partnervorname;
          fperson.Partnernachname := Persontab[h2].Partnernachname;
          fperson.Partnertelefon := Persontab[h2].Partnertelefon;
          fperson.Satzart := True;
          CBPersArt.Text := fperson.Art;
          CBPartnerAnr.Text := fperson.Partneranrede;
          EdtVorname.Text := fperson.Vorname;
          EdtName.Text := fperson.Nachname;
          EdtStrasse.Text := fperson.Strasse;
          EdtHausNr.Text := fperson.Hausnummer;
          EdtPLZ.Text := fperson.Plz;
          EdtOrt.Text := fperson.Ort;
          EdtTel.Text := fperson.Telefon;
          EdtHandy.Text := fperson.Handy;
          EdtFirmenname.Text := fperson.Firmenname;
          EdtMail.Text := fperson.Email;
          EdtLand.Text := fperson.Land;
          EdtPartnerTel.Text := fperson.Partnertelefon;
          EdtPartnerVorname.Text := fperson.Partnervorname;
          EdtPartnerName.Text := fperson.Partnernachname;
          LblNr.Caption := IntToStr(h2);
          JaNein := messagedlg('Person/Firma löschen?', mtConfirmation, [mbYes, mbNo], 0);
          if (JaNein = mrYes) then
          begin
            h2 := fperson.Nummer;
            Persontab[h2].Satzart := False;
            Personzaehl := Personzaehl - 1;
            Updperson := True;
            Ladenpersonen;
          end;
          flauf := 0;
          fart := 0;
          ftasts := True;
          FBLoe;
        end
        else
        begin
          LblUnten.Caption := 'Perosnennummer nicht zulässig';
        end;
      end
      else
      begin
        LblUnten.Caption := 'Perosnennummer ist leer';
      end;
    end
    else
    begin
      LblUnten.Caption := 'erst Person/Firma im Stringgrid anklicken';
    end;
  end;
end;

procedure TFrame2.SGEintraegeSelectCell(Sender: TObject; aCol, aRow: Integer; var CanSelect: Boolean);
begin
  aCol := aCol;
  fgrid := aRow;
  CanSelect := True;
end;

procedure TFrame2.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  Ladenpersonen;
end;

procedure TFrame2.SetVariables(aialpha: String; ainummer, aiart, ainumkom, aikomma, aizeich, aistell, aifunc, ailanmax, ailanmin, aiautocr: Integer);
begin
  ialpha := aialpha;
  inummer := ainummer;
  iart := aiart;
  inumkom := ainumkom;
  ikomma := aikomma;
  izeich := aizeich;
  istell := aistell;
  ifunc := 5;
  ilanmax := ailanmax;
  ilanmin := ailanmin;
  iautocr := aiautocr;
end;

procedure TFrame2.SetControlStatus(ctrl: TObject; aenabled: Boolean; atext: String); //if text=@ then don't change
var
  idx: Integer;
  acolor: TColor;
begin
  if not ((ctrl is TEdit) or (ctrl is TComboBox)) then
    exit;
  if aenabled then
    acolor := $0080FFFF
  else
    acolor := $00C0C0C0;
  if ctrl is TEdit then
  begin
    TEdit(ctrl).Enabled := aenabled;
    TEdit(ctrl).ReadOnly := not aenabled;
    TEdit(ctrl).TabStop := aenabled;
    TEdit(ctrl).Color := acolor;
    if atext <> '@' then
      TEdit(ctrl).Text := atext;
    if aenabled then
      TEdit(ctrl).SetFocus;
  end
  else if ctrl is TComboBox then
  begin
    TComboBox(ctrl).Enabled := aenabled;
    TComboBox(ctrl).ReadOnly := not aenabled;
    TComboBox(ctrl).TabStop := aenabled;
    TComboBox(ctrl).Color := acolor;
    idx := -1;
    if (atext <> '') and (atext <> '@') then
      idx := TComboBox(ctrl).Items.IndexOf(atext);
    if atext <> '@' then
      TComboBox(ctrl).ItemIndex := idx;
    if aenabled then
      TComboBox(ctrl).SetFocus;
  end;
end;

constructor TFrame2.Create(AOwner1: TComponent);
var
  j: Integer;
begin
  inherited Create(AOwner);
  AOwner1 := AOwner1;
  ftasts := True;
  fart := 0;
  flauf := 0;
  fgrid := 0;
  SetControlStatus(CBPersArt, False);
  CBPersArt.Items.Clear;
  CBPersArt.Items.Add('Person');
  CBPersArt.Items.Add('Firma');
  SetControlStatus(CBPartnerAnr, False);
  CBPartnerAnr.Items.Clear;
  CBPartnerAnr.Items.Add('ohne');
  CBPartnerAnr.Items.Add('Herr');
  CBPartnerAnr.Items.Add('Frau');
  SetControlStatus(EdtVorname, False);
  SetControlStatus(EdtName, False);
  SetControlStatus(EdtStrasse, False);
  SetControlStatus(EdtHausNr, False);
  SetControlStatus(EdtPLZ, False);
  SetControlStatus(EdtOrt, False);
  SetControlStatus(EdtTel, False);
  SetControlStatus(EdtHandy, False);
  SetControlStatus(EdtFirmenname, False);
  SetControlStatus(EdtMail, False);
  SetControlStatus(EdtLand, False);
  SetControlStatus(EdtPartnerTel, False);
  SetControlStatus(EdtPartnerVorname, False);
  SetControlStatus(EdtPartnerName, False);
  LblHeader.Caption := UTF8Encode(#169) + 'LINSOFT               Projektverwaltung                   Datum: ' + FormatDateTime('DD.MM.YYYY', now);
  LblUnten.Caption := '';
  SGEintraege.RowCount := 2;
  SGEintraege.ColCount := 17;
  SGEintraege.ColWidths[0] := 120;
  SGEintraege.ColWidths[1] := 110;
  SGEintraege.ColWidths[2] := 500;
  SGEintraege.ColWidths[3] := 430;
  SGEintraege.ColWidths[4] := 430;
  SGEintraege.ColWidths[5] := 500;
  SGEintraege.ColWidths[6] := 170;
  SGEintraege.ColWidths[7] := 180;
  SGEintraege.ColWidths[8] := 500;
  SGEintraege.ColWidths[9] := 350;
  SGEintraege.ColWidths[10] := 350;
  SGEintraege.ColWidths[11] := 500;
  SGEintraege.ColWidths[12] := 500;
  SGEintraege.ColWidths[13] := 130;
  SGEintraege.ColWidths[14] := 350;
  SGEintraege.ColWidths[15] := 430;
  SGEintraege.ColWidths[16] := 430;
  SGEintraege.Cells[0, 0] := 'Nummer';
  SGEintraege.Cells[1, 0] := 'Art';
  SGEintraege.Cells[2, 0] := 'Firmenname';
  SGEintraege.Cells[3, 0] := 'Vorname';
  SGEintraege.Cells[4, 0] := 'Nachname';
  SGEintraege.Cells[5, 0] := 'Strasse';
  SGEintraege.Cells[6, 0] := 'Hausnummer';
  SGEintraege.Cells[7, 0] := 'PLZ';
  SGEintraege.Cells[8, 0] := 'Ort';
  SGEintraege.Cells[9, 0] := 'Telefon';
  SGEintraege.Cells[10, 0] := 'Handy';
  SGEintraege.Cells[11, 0] := 'EMail';
  SGEintraege.Cells[12, 0] := 'Land';
  SGEintraege.Cells[13, 0] := 'PAnrede';
  SGEintraege.Cells[14, 0] := 'PTelefon';
  SGEintraege.Cells[15, 0] := 'Partnervorname';
  SGEintraege.Cells[16, 0] := 'Partnernachname';
  for j := 0 to SGEintraege.ColCount - 1 do
    SGEintraege.Cells[j, 1] := '';
  BuAendern.Visible := False;
  BuLoeschen.Visible := False;
  if Personzaehl > 0 then
  begin
    BuAendern.Visible := True;
    BuLoeschen.Visible := True;
  end;
end;

procedure TFrame2.FBLoe;
begin
  SetControlStatus(CBPersArt, False);
  SetControlStatus(CBPartnerAnr, False);
  SetControlStatus(EdtVorname, False);
  SetControlStatus(EdtName, False);
  SetControlStatus(EdtStrasse, False);
  SetControlStatus(EdtHausNr, False);
  SetControlStatus(EdtPLZ, False);
  SetControlStatus(EdtOrt, False);
  SetControlStatus(EdtTel, False);
  SetControlStatus(EdtHandy, False);
  SetControlStatus(EdtFirmenname, False);
  SetControlStatus(EdtMail, False);
  SetControlStatus(EdtLand, False);
  SetControlStatus(EdtPartnerTel, False);
  SetControlStatus(EdtPartnerVorname, False);
  SetControlStatus(EdtPartnerName, False);
end;

procedure TFrame2.Ladenpersonen;
var
  z, j: Integer;
  h1: Integer;
  h2: String;
begin
  z := 1;
  Screen.Cursor := crHourGlass;
//  Form1.Frame2.Cursor := crHourGlass;  // Erledigt Scrren
  Refresh;
  for h1 := 1 to Personmax do
  begin
    if Persontab[h1].Satzart then
    begin
      z := z + 1;
      SGEintraege.RowCount := z;
      z := z - 1;
      SGEintraege.Cells[0, z] := IntToStr(Persontab[h1].Nummer);
      SGEintraege.Cells[1, z] := Persontab[h1].Art;
      SGEintraege.Cells[2, z] := Persontab[h1].Firmenname;
      SGEintraege.Cells[3, z] := Persontab[h1].Vorname;
      SGEintraege.Cells[4, z] := Persontab[h1].Nachname;
      SGEintraege.Cells[5, z] := Persontab[h1].Strasse;
      SGEintraege.Cells[6, z] := Persontab[h1].Hausnummer;
      SGEintraege.Cells[7, z] := Persontab[h1].Plz;
      SGEintraege.Cells[8, z] := Persontab[h1].Ort;
      SGEintraege.Cells[9, z] := Persontab[h1].Telefon;
      SGEintraege.Cells[10, z] := Persontab[h1].Handy;
      SGEintraege.Cells[11, z] := Persontab[h1].Email;
      SGEintraege.Cells[12, z] := Persontab[h1].Land;
      h2 := Persontab[h1].Partneranrede;
      if h2 = 'ohne' then h2 := '';
      SGEintraege.Cells[13, z] := h2;
      SGEintraege.Cells[14, z] := Persontab[h1].Partnertelefon;
      SGEintraege.Cells[15, z] := Persontab[h1].Partnervorname;
      SGEintraege.Cells[16, z] := Persontab[h1].Partnernachname;
      z := z + 1;
    end;
    Label20.Caption := IntToStr(Personzaehl);
  end;
  Screen.Cursor := crDefault;
  Refresh;
  if z = 1 then
  begin
    SGEintraege.RowCount := 2;
    for j := 0 to SGEintraege.ColCount - 1 do
      SGEintraege.Cells[j, 1] := '';
  end;
  fgrid := 0;
end;

end.
